<!--
 * @Author: zhp
 * @Date: 2023-04-17 14:23:17
 * @LastEditTime: 2023-06-20 15:39:07
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <el-tabs @tab-click="clickTabs" tab-position="left" style="height: 200px;">
        <el-tab-pane v-for="(item,index) in projectTypeList" :name="item.id" :key="index" :label="item.name">
          <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
          </SearchBar>
          <base-table id="palletTable" :table-props="tableProps" :page="listQuery.page" ref="palletTable1" :limit="listQuery.limit" :table-data="tableData">
            <method-btn v-if="tableBtn.length" slot="handleBtn" :width="100" label="操作" :method-list="tableBtn"
              @clickBtn="handleClick" />
          </base-table>
          <pagination :limit.sync="listQuery.limit" :page.sync="listQuery.page" :total="listQuery.total"
            @pagination="getDataList" />
        </el-tab-pane>
      </el-tabs>
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog :dialogTitle="addOrEditTitle" :dialogVisible="addOrUpdateVisible" @cancel="handleCancel"
        @confirm="handleConfirm" :before-close="handleCancel">
        <evaluationItemList-add ref="addOrUpdate" @refreshDataList="successSubmit">
          </evaluationItemList-add>
          <!-- <el-row slot="footer" type="flex" justify="end"> </el-row> -->
      </base-dialog>
      <base-dialog :dialogTitle="searchOrEditTitle" :dialogVisible="searchOrUpdateVisible" @cancel="handleSearchCancel"
        @confirm="handleSearchConfirm" :before-close="handleSearchCancel">
        <supplierProduct-search ref="searchOrUpdate" @successSubmit="conditionSearchSubmit">
        </supplierProduct-search>
        <el-row slot="footer" type="flex" justify="end">
          <el-col :span="12">
            <el-button size="small" type="primary" plain class="btnTextStyle" @click="handleSearchCancel">
              {{ $t("close") }}
            </el-button>
            <el-button size="small" class="btnTextStyle" type="primary" plain @click="handleSearchReset">{{
              $t("reset")
              }}</el-button>
            <el-button type="primary" size="small" class="btnTextStyle" @click="handleSearchConfirm">
              {{ $t("search") }}
            </el-button>
          </el-col>
        </el-row>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page"
import basicSearch from "@/mixins/basic-search"
import supplierProductSearch from "./components/supplierProductSearch.vue"
import evaluationItemListAdd from "./components/evaluationItemList-add.vue"
import { timeFormatter } from '@/filters'
import i18n from "@/i18n"
// import i18n from "@/i18n";
const tableProps = [
  {
    prop: "title",
    label: i18n.t('supplier.title')
  },
  {
    prop: "projectTypeName",
    label: i18n.t('supplier.projectTypeName')
  },
  {
    prop: "requirement",
    label: i18n.t('supplier.requirement')
  }
];
const tableBtn = [
  {
    type: "edit",
    btnName: i18n.t('t.edit'),
  },
  {
    type: "delete",
    btnName: i18n.t('t.delete'),
  }
];
export default {
  mixins: [basicPage, basicSearch],
  data() {
    return {
      urlOptions: {
        getDataListURL: "/supplier/qmsEvaluationItemList/page",
        deleteURL: "/supplier/qmsEvaluationItemList",
        getProjectTypeList: '/supplier/qmsProjectType/page'
        // submitURL: '/supplier/qmsSupplierType'
      },
      tableProps,
      ment: '',
      tableBtn,
      productData: {},
      dataForm:{
        limit: 999,
        page:1
      },
      projectTypeId:null,
      projectTypeList:[],
      searchOrEditTitle: "",
      searchOrUpdateVisible: false,
      productOrEditTitle: "",
      addOrEditTitle: '',
      addOrUpdateVisible: false,
      productOrUpdateVisible: false,
      formConfig: [
        {
          type: 'input',
          label: i18n.t('supplier.name'),
          placeholder: i18n.t('supplier.name'),
          param: 'name'
        },
        {
          type: 'input',
          label: i18n.t('supplier.code'),
          placeholder: i18n.t('supplier.code'),
          param: 'code'
        },
        {
          type: "button",
          btnName: i18n.t('search'),
          name: "search",
          color: "primary",
          // plain: true,
        },
        {
          type: "button",
          btnName: i18n.t('add'),
          name: "add",
          color: "primary",
          // plain: true,
        },
      ],
    };
  },
  components: {
    supplierProductSearch,
    // supplierProduct,
    evaluationItemListAdd
  },
  mounted () {
    this.getData()
  },
  methods: {
    clickTabs(e) {
      this.projectTypeId = e.name
      this.listQuery.projectTypeId = e.name
      this.getDataList();
    },
    getData() {
      this.$http
        .get(this.urlOptions.getProjectTypeList, { params: this.listQuery })
        .then(({ data: res }) => {
          if (res.code === 0) {
            console.log(res.data);
            this.projectTypeList = res.data.list
          }
        })
        .catch(() => {
        })
    },
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = ""
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init();
      });
    },
    exportHandle() {
      this.$http.get(this.urlOptions.exportURL, { responseType: 'blob' }, {
        ...this.dataForm
      }).then((res) => {
        console.log(res)
        // if (res !== 0) {
        //   return this.$message.error(res.msg) 
        // }
        let fileName = ''
        const contentDisposition = res.headers['content-disposition']
        if (contentDisposition) {
          const temp = res.headers['content-disposition']
            .split(';')[1]
            .split('=')[1]
          // 对文件名乱码转义--【Node.js】使用iconv-lite解决中文乱码
          fileName = decodeURI(temp)
          console.log(temp)
        }
        const blob = new Blob([res.data])
        const reader = new FileReader()
        reader.readAsDataURL(blob)
        reader.onload = (e) => {
          const a = document.createElement('a')
          a.download = fileName
          a.href = e.target.result
          document.body.appendChild(a)
          a.click()
          document.body.removeChild(a)
        }
      }).catch(() => { })
    },
    // handleConfirm() {
    //   this.$refs.addOrUpdate.dataFormSubmitHandle();
    // },
    // conditionSearchSubmit() {},
    conditionSearchSubmit(dataForm) {
      // console.log(key);
      // console.log(key);
      this.listQuery.supplierName = dataForm.supplierName
      this.listQuery.page = 1;
      this.getDataList();
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    handleClick(val) {
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.customerTypeName}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http.delete(this.urlOptions.deleteURL, { data: [val.data.id] }).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList();
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => { });
      } else if (val.type === 'edit') {
        this.addOrUpdateVisible = true
        this.addOrEditTitle = this.$t('edit')
        this.$nextTick(() => {
          const data ={
            id: val.data.id, 
            projectTypeId: this.projectTypeId
          }
          this.$refs.addOrUpdate.init(data)
        });
      }
    },
    addOrUpdateHandle() {
      console.log(this.projectTypeId)
      this.addOrUpdateVisible = true;
      this.$nextTick(() => {
        const data = {
          projectTypeId: this.projectTypeId
        }
        this.$refs.addOrUpdate.init(data)
      });
    },
    buttonClick(val) {
      console.log(val)
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.name = val.name ? val.name : undefined
          this.listQuery.code = val.code ? val.code : undefined
          // console.log(i18n);
          this.listQuery.page = 1;
          this.getDataList();
          break;
        case "add":
          this.addOrEditTitle = '新增'
          this.addOrUpdateVisible = true
          this.addOrUpdateHandle()
          break;
        default:
      }
    },
  },
};
</script>
